-- Copyright (C) 2018  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details.

-- Generated by Quartus Prime Version 18.0.0 Build 614 04/24/2018 SJ Standard Edition
-- Created on Mon Jan 16 00:59:29 2023

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ControlDevice IS
    PORT (
        reset : IN STD_LOGIC := '0';
        clock : IN STD_LOGIC;
        sno : IN STD_LOGIC := '0';
        cop : IN STD_LOGIC := '0';
        x1 : IN STD_LOGIC := '0';
        x2 : IN STD_LOGIC := '0';
        y : OUT STD_LOGIC_VECTOR(11 DOWNTO 0);
        sko : OUT STD_LOGIC;
        S : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
    );
END ControlDevice;

ARCHITECTURE BEHAVIOR OF ControlDevice IS
    TYPE type_fstate IS (S0,S1,S4,S5,S6,S7,S3,S2);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
    SIGNAL reg_y : STD_LOGIC_VECTOR(11 DOWNTO 0) := "000000000000";
BEGIN
    PROCESS (clock,reg_fstate)
    BEGIN
        IF (clock='1' AND clock'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,reset,sno,cop,x1,x2,reg_y)
    BEGIN
        IF (reset='1') THEN
            reg_fstate <= S0;
            reg_y <= "000000000000";
            y <= "000000000000";
            sko <= '0';
            S <= "000";
        ELSE
            reg_y <= "000000000000";
            sko <= '0';
            S <= "000";
            y <= "000000000000";
            CASE fstate IS
                WHEN S0 =>
                    IF ((sno = '1')) THEN
                        reg_fstate <= S1;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= S0;
                    END IF;

                    IF ((sno = '1')) THEN
                        reg_y <= "000001111111";
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_y <= "000000000000";
                    END IF;

                    S <= "000";
                WHEN S1 =>
                    IF (NOT((cop = '1'))) THEN
                        reg_fstate <= S6;
                    ELSIF (((cop = '1') AND NOT((x2 = '1')))) THEN
                        reg_fstate <= S2;
                    ELSIF (((cop = '1') AND (x2 = '1'))) THEN
                        reg_fstate <= S3;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= S1;
                    END IF;

                    IF (((cop = '1') AND (x2 = '1'))) THEN
                        reg_y <= "000111000000";
                    ELSIF (((cop = '1') AND NOT((x2 = '1')))) THEN
                        reg_y <= "000001110000";
                    ELSIF (NOT((cop = '1'))) THEN
                        reg_y <= "001011000000";
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_y <= "000000000000";
                    END IF;

                    S <= "001";
                WHEN S4 =>
                    reg_fstate <= S5;

                    reg_y <= "001111000000";

                    S <= "100";
                WHEN S5 =>
                    reg_fstate <= S0;

                    sko <= '1';

                    S <= "101";
                WHEN S6 =>
                    reg_fstate <= S7;

                    reg_y <= "010000000000";

                    S <= "110";
                WHEN S7 =>
                    reg_fstate <= S0;

                    sko <= '1';

                    S <= "111";
                WHEN S3 =>
                    reg_fstate <= S2;

                    reg_y <= "000001110000";

                    S <= "011";
                WHEN S2 =>
                    IF (((x1 = '1') AND NOT((x2 = '1')))) THEN
                        reg_fstate <= S0;
                    ELSIF (((x1 = '1') AND (x2 = '1'))) THEN
                        reg_fstate <= S4;
                    ELSIF ((NOT((x1 = '1')) AND (x2 = '1'))) THEN
                        reg_fstate <= S3;
                    ELSIF ((NOT((x1 = '1')) AND NOT((x2 = '1')))) THEN
                        reg_fstate <= S2;
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_fstate <= S2;
                    END IF;

                    IF (((x1 = '1') AND NOT((x2 = '1')))) THEN
                        sko <= '1';
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        sko <= '0';
                    END IF;

                    IF (((x1 = '1') AND (x2 = '1'))) THEN
                        reg_y <= "001011000000";
                    ELSIF ((NOT((x1 = '1')) AND (x2 = '1'))) THEN
                        reg_y <= "000111000000";
                    ELSIF ((NOT((x1 = '1')) AND NOT((x2 = '1')))) THEN
                        reg_y <= "000001110000";
                    -- Inserting 'else' block to prevent latch inference
                    ELSE
                        reg_y <= "000000000000";
                    END IF;

                    S <= "010";
                WHEN OTHERS => 
                    reg_y <= "XXXXXXXXXXXX";
                    sko <= 'X';
                    S <= "XXX";
                    report "Reach undefined state";
            END CASE;
            y <= reg_y;
        END IF;
    END PROCESS;
END BEHAVIOR;
